/*_______       _______                                         _        _      _______
|       |     |                 /\          |                 | \      / |    |           |\      |    |         |  
|       |     |                /  \         |                 |  \    /  |    |           | \     |    |         |
|       |     |               /    \        |                 |   \  /   |    |           |  \    |    |         |
|_______|     |_______       /      \       |          ____   |    \/    |    |_______    |   \   |    |         |
|      \      |             /________\      |                 |          |    |           |    \  |    |         |
|       \     |_______     /          \     |_______          |          |    |_______    |      \|     \_______/
*/

/*
* - ----------
Плагин - "Real-Menu" // Rus: "Реальное-меню"
* - ---------- 
Благодарность за помощь (содействие): Mistrick, w0w, Minni, zhorzh78
* - ---------- 
Благодарность за перевод на разные языки: wellasgood
* - ---------- 
Поддержка плагина:
* - ---------- 
Dev-Cs: @wellasgood 
vk: https://vk.com/d1mkin
Telegram: @WellAsGood

** Description:
* - For all servers (fun maps)
* - For Public maps: 35hp_~ | 1hp_~ | he_~ | ~

** Commands:
* - Say: /real-menu, /rm

** Functions:
* - Speed gamer (standart)
* - Speed gamer (kayot)
* - Speed gamer (gipard)
* - Speed gamer (pyl9)
* - Shield
* - Gravity (on & off)
* - NoClip (on & off)
* - Spawn
* - Hide [NEW! ver 1.4]

** Version:
* - Tested version '0.1 - 0.9':
1) Подготовка и настройка основ.

* - Stability version '1.0':
1) Добавлены множественные проверки.
2) Добавлено музыкальное сопровождение.
3) Переработано меню.
4) Добавлены различные условия в меню.
5) Добавлены нужные define.
6) Добавлены переменные (способности, счетчики и тп).
7) Добавлены инфо-оповещания в чате основываясь из различных условий (глобал, лимитер, услуги).
8) Добавлена система лимитов на использование функций.
9) Добавлена система пробных попыток использования всем юзерам.
10) Добавлена система ограничения по времени после использования способности.
11) Добавлена система отключения карт на которых не должен работать плагин.
12) Вынесены нужные константы.
13) Добавлена система раундов (с какого раунда можно использовать плагин).
14) Оптимизация хеширования и другое подобное.
15) Очень гибкая настройка всего с описанием.
16) Общая проверка и оптимизация кода.
17) Проверка всех функций и общей работоспособности всего плагина в игре.
18) UPD пункта, поддержка 182 убрана.
19) Все сообщения вынесены в Lang файл + пункты меню (пока что языки: ru, en)
20) Подготовка плагина для возможного усовершенствования (создана удобная среда)
21) Добавлен define c мульти флаговым биндом для пробного периода (меняется на свой вкус и цвет)
22) И другое... -_- *_* -_- (дело было вечером, делоть было нечего)
23) В продолжение: Добавлены ограничения по времени использования способности (не путать с временем до повторного активирования)
24) Добавлены новые инфо-оповещания к соотвествующим функциям, исходя из разнх условий.
25) Переработаны некторые моменты (оптимизация кода)
26) Пофикшены некоторые баги, исходя из проверки в игре.
27) Переработан код, из обычных переменных сделаны массивы, для уникальности значений для каждого игрока.
28) Доработка: Так как массивы, то при дисконнекте игрока сбрасываем все используемые счетчики на 0, а переключатели на false.
29) Добавлено: Основная озвучка по пути: sound/real-menu и Default озвучка по пути: sound/real-menu/default. (при необходимости вытащить из папки Default и кинуть с заменой)
30) Музыка читается из папки: sound/real-menu. (по этому вся музыка которую Вы хотите использовать должна находиться по пути: sound/real-menu)
*/

/*
** Раздел обновлений:

* - Version '1.1':
1) Убрана поддержка AMXX 1.8.2  и ниже.
2) Переработаны функции вывода звука в игре игрокам, теперь звуки слышат Steam и Non-Steam. (Спасибо w0w и Minni)
3) Исправлены некоторые моменты. (const, precache_sound)
4) Добавлено ограничение на включение музыки при входе в меню для игрока. (RM_SOUND_MENU_STOP)
5) Переработан код в некоторых местах.
6) Удалены некоторые файлы, в которых нет необходимости. (папка include)

* - Version '1.2':
1) register_cvar заменено на create_cvar
2) Изменены сообщения HUD (оптимизация)
3) Поправлен LANG файл
4) Поправлена подстановка в массиве с MAX_PLAYERS на MAX_MAPNAME_LENGTH (по свойствам кода map = MAX_MAPNAME_LENGTH)
4) Отключение не нужных карт, перемещено после регистрации плагина.
5) При отключении карт (префиксов), если после префа карты идет '_', пример: awp_, то нужно вписывать так: "awp_", "cs_" и тп.

* - Version '1.3':
1) Поправлены значения create_cvar в коде (значение были больше максимального 32) теперь лимиты таких кваров убраны.

* - Version '1.4':
1) Добавлена способность невидимость. (и все сопутствующее: include engine, нужные переменные и правки в коде).
2) Подправлены функции звука SendAudio (убрано fmt).
3) Изменен LANG файл.

* - Version '1.5':
1) Убран мешающий код (отключение карт)
2) Добавлена поддержка CFG (настройки плагина теперь в cfg)
3) Внесение правок в код (небольшая оптимизация)
4) Добавлены новые const связанные с CFG

* - Version '1.6':
1) В старой версии, было указание закомментировать #define MULTI_FLAGS (если не использовать систему пробного периода) и это приводило к ошибке компиляции. Нет необходимости это делать, так как все зависит от значение квара rm_limiter_user, а define лишь определяет наличие флага. (fix)

* - Version '1.0.7':
1) Переход на 3-х значную версию
2) Поправлены некоторые create_cvar, в части ограничения значений кваров. К примеру: 'true, 0.0, true, 32.0', а по коду нужно/можно значение больше/меньше чем 32..
*/

#include <amxmodx>
#include <amxmisc>
#include <fun>
#include <engine>

#if !defined MAX_MAPNAME_LENGTH
#define MAX_MAPNAME_LENGTH 64
#endif

// ~ Дефайн с биндом флагов (глобал) ~
#define GL_FLAG ADMIN_BAN  //Бинд флага (меняется на какой хотите, только с этим флагом, будут доступны: основные функции)
#define MULTI_FLAGS (ADMIN_USER|ADMIN_LEVEL_H)  //Мульти бинд флагов (например для вип и юзеров, только с этими флагами будут доступны: пробный период (пробные разы))

//Дефайн для plugin_precache (проверка), закомментировать если нехотим что бы скачивалась музыка.. глобал и для меню
#define RM_SOUND_GL //активирует скачку всех песен
#define RM_SOUND_MN //включить или выключить скачку отдельно для меню (основываясь из RM_SOUND_MENU)

//константы названия плагина, версии плагина, автора плагина
new const PLUGIN[] = "Real-Menu";
new const VERSION[] = "1.0.7";
new const AUTHOR[] = "wellasgood";

//константы музыки
new const RM_SND_YES[] = "real-menu/yes.wav";
new const RM_SND_NO[] = "real-menu/no.wav";
new const RM_SND_HELLO[] = "real-menu/hello.wav";

new const RM_DIR[] = "real-menu";
new const RM_CFG[] = {"addons/amxmodx/configs/real-menu/real-menu.cfg"};

//цветное меню, раунд
new g_ColorMenu, g_Round;

//2 страница меню
new g_NextMenu[MAX_PLAYERS+1];

//счетчики ограничителей
new g_limit_sp1[MAX_PLAYERS+1];
new g_limit_sp2[MAX_PLAYERS+1];
new g_limit_sp3[MAX_PLAYERS+1];
new g_limit_gr[MAX_PLAYERS+1];
new g_limit_sh[MAX_PLAYERS+1];
new g_limit_nc[MAX_PLAYERS+1];
new g_limit_spw[MAX_PLAYERS+1];
new g_limit_hide[MAX_PLAYERS+1];

//счетчики ограничителей для пробного периода (юзеры)
new g_lm_sp1_user[MAX_PLAYERS+1];
new g_lm_sp2_user[MAX_PLAYERS+1];
new g_lm_sp3_user[MAX_PLAYERS+1];
new g_lm_gr_user[MAX_PLAYERS+1];
new g_lm_sh_user[MAX_PLAYERS+1];
new g_lm_nc_user[MAX_PLAYERS+1];
new g_lm_spw_user[MAX_PLAYERS+1];
new g_lm_hide_user[MAX_PLAYERS+1];

//счетчик времени лимита до повторного использования способности
new g_ReloadTime[MAX_PLAYERS+1];

//переключатели времени лимита на использование способности по времени
new bool:g_abilities_sp1[MAX_PLAYERS+1];
new bool:g_abilities_sp2[MAX_PLAYERS+1];
new bool:g_abilities_sp3[MAX_PLAYERS+1];
new bool:g_abilities_gr[MAX_PLAYERS+1];
new bool:g_abilities_nc[MAX_PLAYERS+1];
new bool:g_abilities_hd[MAX_PLAYERS+1];

//переключатель для соунда меню
new bool:g_sound_menu[MAX_PLAYERS+1] = false;

//раундные переменные
new RM_ROUND, RM_ROUND_COUNT;

//скоростные переменные
new RM_SPEED_1, RM_SPEED_2, RM_SPEED_3;

//гравитационная переменная
new RM_GRAVITY;

//ограничительные переменные (обычные)
new RM_LIMITER, RM_LIMITER_SPEED1, RM_LIMITER_SPEED2, RM_LIMITER_SPEED3, RM_LIMITER_GRAVITY, RM_LIMITER_SHIELD, RM_LIMITER_NOCLIP, RM_LIMITER_SPAWN, RM_LIMITER_HIDE;

//ограничительные переменные (пробный период)
new RM_LIMITER_USER, RM_LM_SPEED1_USER, RM_LM_SPEED2_USER, RM_LM_SPEED3_USER, RM_LM_GRAVITY_USER, RM_LM_SHIELD_USER, RM_LM_NOCLIP_USER, RM_LM_SPAWN_USER, RM_LM_HIDE_USER;

//звуковые переменные
new RM_SOUND_GLOBAL, RM_SOUND_MENU;

//переменные для отсчета времени до повторного использования способности
new RM_TIMER_ENABLED, RM_TIMER_TIME;

//переменные для отсчета времени до конца способности (способность дается на время)
new RM_ABILITIES_ENABLED, RM_ABILITIES_SPEED1, RM_ABILITIES_SPEED2, RM_ABILITIES_SPEED3, RM_ABILITIES_GRAVITY, RM_ABILITIES_NOCLIP, RM_ABILITIES_HIDE;

//Ограничительная переменная для музыки меню
new RM_SOUND_MENU_STOP;

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR);

	register_logevent("round_start", 2, "0=World triggered", "1=Round_Start")
	register_dictionary("real-menu.txt");

	register_clcmd("say /real-menu", "cmdRealMenu", ADMIN_ALL)
	register_clcmd("say /rm", "cmdRealMenu", ADMIN_ALL)
	register_menu("Real-Menu", 1023, "realMenu")
	register_menu("Next-Menu", 1023, "nextMenu")

	RM_ROUND = create_cvar("rm_round","1", FCVAR_NONE, "Round system", true, 0.0, true, 1.0); // вкл/выкл. (1/0) систему лимитов на раунды
	RM_ROUND_COUNT = create_cvar("rm_round_count","3", FCVAR_NONE, "Round Count", false, 0.0, false, 0.0); // кол-во раундов, после которых можно юзать функции плагина (команду)

	RM_SPEED_1 = create_cvar("rm_speed1","1000", FCVAR_NONE, "Speed abilities 1", false, 0.0, false, 0.0); // устанавливаем скорость кайот
	RM_SPEED_2 = create_cvar("rm_speed2","2000", FCVAR_NONE, "Speed abilities 2", false, 0.0, false, 0.0); // устанавливаем скорость гипард
	RM_SPEED_3 = create_cvar("rm_speed3","3000", FCVAR_NONE, "Speed abilities 3", false, 0.0, false, 0.0); // устанавливаем скорость пуля

	RM_GRAVITY = create_cvar("rm_gravity","0.3", FCVAR_NONE, "Gravity abilities", false, 0.0, false, 0.0); //1.0 = 800 гравити, если ставим 0.3 то грав-ция 300

	RM_LIMITER = create_cvar("rm_limiter","1", FCVAR_NONE, "Limit system", true, 0.0, true, 1.0); // вкл/выкл. (1/0) лимиты функций (если 0, то сколько хочешь)
	RM_LIMITER_SPEED1 = create_cvar("rm_lm_speed1","5", FCVAR_NONE, "Limit speed 1", false, 0.0, false, 0.0); // ограничитель на кол-во раз использований данной функции
	RM_LIMITER_SPEED2 = create_cvar("rm_lm_speed2","5", FCVAR_NONE, "Limit speed 2", false, 0.0, false, 0.0); // ограничитель на кол-во раз использований данной функции 
	RM_LIMITER_SPEED3 = create_cvar("rm_lm_speed3","5", FCVAR_NONE, "Limit speed 3", false, 0.0, false, 0.0); // ограничитель на кол-во раз использований данной функции
	RM_LIMITER_GRAVITY = create_cvar("rm_lm_gravity","5", FCVAR_NONE, "Limit gravity", false, 0.0, false, 0.0); // ограничитель на кол-во раз использований данной функции
	RM_LIMITER_SHIELD = create_cvar("rm_lm_shield","3", FCVAR_NONE, "Limit shield", false, 0.0, false, 0.0); // ограничитель на кол-во раз использований данной функции
	RM_LIMITER_NOCLIP = create_cvar("rm_lm_noclip","2", FCVAR_NONE, "Limit noclip", false, 0.0, false, 0.0); // ограничитель на кол-во раз использований данной функции
	RM_LIMITER_SPAWN = create_cvar("rm_lm_spawn","3", FCVAR_NONE, "Limit spawn", false, 0.0, false, 0.0); // ограничитель на кол-во раз использований данной функции
	RM_LIMITER_HIDE = create_cvar("rm_lm_hide","5", FCVAR_NONE, "Limit hide", false, 0.0, false, 0.0); // ограничитель на кол-во раз использований данной функции

	RM_LIMITER_USER = create_cvar("rm_limiter_user","1", FCVAR_NONE, "Limit user system", true, 0.0, true, 1.0); // вкл/выкл. (1/0) лимиты функций (пробный период для юзеров)
	RM_LM_SPEED1_USER = create_cvar("rm_lm_sp1_us","2", FCVAR_NONE, "Limit user speed 1", false, 0.0, false, 0.0); // ограничитель на кол-во раз использований данной функции
	RM_LM_SPEED2_USER = create_cvar("rm_lm_sp2_us","2", FCVAR_NONE, "Limit user speed 2", false, 0.0, false, 0.0); // ограничитель на кол-во раз использований данной функции
	RM_LM_SPEED3_USER = create_cvar("rm_lm_sp3_us","2", FCVAR_NONE, "Limit user speed 3", false, 0.0, false, 0.0); // ограничитель на кол-во раз использований данной функции
	RM_LM_GRAVITY_USER = create_cvar("rm_lm_gr_us","2", FCVAR_NONE, "Limit user gravity", false, 0.0, false, 0.0); // ограничитель на кол-во раз использований данной функции
	RM_LM_SHIELD_USER = create_cvar("rm_lm_sh_us","2", FCVAR_NONE, "Limit user shield", false, 0.0, false, 0.0); // ограничитель на кол-во раз использований данной функции
	RM_LM_NOCLIP_USER = create_cvar("rm_lm_nc_us","2", FCVAR_NONE, "Limit user noclip", false, 0.0, false, 0.0); // ограничитель на кол-во раз использований данной функции
	RM_LM_SPAWN_USER = create_cvar("rm_lm_spw_us","2", FCVAR_NONE, "Limit user spawn", false, 0.0, false, 0.0); // ограничитель на кол-во раз использований данной функции
	RM_LM_HIDE_USER = create_cvar("rm_lm_hide_us","2", FCVAR_NONE, "Limit user hide", false, 0.0, false, 0.0); // ограничитель на кол-во раз использований данной функции

	RM_SOUND_GLOBAL = create_cvar("rm_sound_gl","1", FCVAR_NONE, "Sound global", true, 0.0, true, 1.0); // вкл/выкл проигрывание музыки при результате функций плагина (1/0)
	RM_SOUND_MENU = create_cvar("rm_sound_mn","1", FCVAR_NONE, "Sound menu", true, 0.0, true, 1.0); // вкл/выкл проигрывание музыки при открытии меню (приветствие) (1/0)
	RM_SOUND_MENU_STOP = create_cvar("rm_sound_mn_st","1", FCVAR_NONE, "Sound menu stop", true, 0.0, true, 1.0); // 1/0, 0 музыка всегда, если 1 то только раз при первом открытии

	RM_TIMER_ENABLED = create_cvar("rm_timer_en","1", FCVAR_NONE, "Timer enabled", true, 0.0, true, 1.0); // вкл/выкл 1/0 (лимит времени, до повторной активации способности)
	RM_TIMER_TIME = create_cvar("rm_timer","30", FCVAR_NONE, "Timer time", false, 0.0, false, 0.0); // Время, после которого можно снова задействовать команду.

	RM_ABILITIES_ENABLED = create_cvar("rm_abilities_en","1", FCVAR_NONE, "Abilities enabled", true, 0.0, true, 1.0); // вкл/выкл. (1/0) способность на время (кроме spawn и shield)
	RM_ABILITIES_SPEED1 = create_cvar("rm_abilities_sp1","25", FCVAR_NONE, "Time abilities speed 1", false, 0.0, false, 0.0); // пишем время на которое будет активирована способность
	RM_ABILITIES_SPEED2 = create_cvar("rm_abilities_sp2","25", FCVAR_NONE, "Time abilities speed 2", false, 0.0, false, 0.0); // пишем время на которое будет активирована способность
	RM_ABILITIES_SPEED3 = create_cvar("rm_abilities_sp3","60", FCVAR_NONE, "Time abilities speed 3", false, 0.0, false, 0.0); // пишем время на которое будет активирована способность
	RM_ABILITIES_GRAVITY = create_cvar("rm_abilities_gr","30", FCVAR_NONE, "Time abilities gravity", false, 0.0, false, 0.0); // пишем время на которое будет активирована способность
	RM_ABILITIES_NOCLIP = create_cvar("rm_abilities_nc","15", FCVAR_NONE, "Time abilities noclip", false, 0.0, false, 0.0); // пишем время на которое будет активирована способность
	RM_ABILITIES_HIDE = create_cvar("rm_abilities_hd","15", FCVAR_NONE, "Time abilities hide", false, 0.0, false, 0.0); // пишем время на которое будет активирована способность

	g_ColorMenu = colored_menus()

	set_task(180.0, "rm_global_info", .flags = "b") // реклама всем в чат до конца карты через определенное время о плагине

	if(get_pcvar_num(RM_LIMITER_USER) == 1){
		set_task(80.0, "rm_global_lm_info", .flags = "b") // реклама всем в чат до конца карты через определенное время о пробном периоде
	}
}

public plugin_cfg()
{
	new paths[64];
	rm_get_configsdir(paths, 63);

	if(!dir_exists(paths)) mkdir(paths);
	if(file_exists(RM_CFG)) server_cmd("exec %s", RM_CFG);
}

#if defined RM_SOUND_GL
public plugin_precache()
{
	precache_sound(RM_SND_YES)
	precache_sound(RM_SND_NO)

#if defined RM_SOUND_MN
	precache_sound(RM_SND_HELLO)
#endif
}
#endif

public round_start()
{
	if(get_pcvar_num(RM_ROUND) == 1){
		g_Round++; // для лимита рундов
	}
}

public client_disconnected(id)
{
	g_NextMenu[id] = 0;

	if(get_pcvar_num(RM_LIMITER) == 1){
		g_limit_sp1[id] = 0;
		g_limit_sp2[id] = 0;
		g_limit_sp3[id] = 0;
		g_limit_gr[id] = 0;
		g_limit_sh[id] = 0;
		g_limit_nc[id] = 0;
		g_limit_spw[id] = 0;
		g_limit_hide[id] = 0;
	}

	if(get_pcvar_num(RM_LIMITER_USER) == 1){
		g_lm_sp1_user[id] = 0;
		g_lm_sp2_user[id] = 0;
		g_lm_sp3_user[id] = 0;
		g_lm_gr_user[id] = 0;
		g_lm_sh_user[id] = 0;
		g_lm_nc_user[id] = 0;
		g_lm_spw_user[id] = 0;
		g_lm_hide_user[id] = 0;
	}

	if(get_pcvar_num(RM_ABILITIES_ENABLED) == 1){
		g_abilities_sp1[id] = false;
		g_abilities_sp2[id] = false;
		g_abilities_sp3[id] = false;
		g_abilities_gr[id] = false;
		g_abilities_nc[id] = false;
		g_abilities_hd[id] = false;
	}

	if(get_pcvar_num(RM_TIMER_ENABLED) == 1){
		g_ReloadTime[id] = 0;
	}

	if(get_pcvar_num(RM_SOUND_MENU_STOP) == 1){
		g_sound_menu[id] = false;
	}
}

public rm_global_info(id)
{
	client_print_color(id, print_team_default, "%l", "RM_GLOBAL_INFO") // Реклама всем в чат о плагиине в голобальном плане
}

public rm_global_lm_info(id)
{
	client_print_color(id, print_team_default, "%l", "RM_GLOBAL_LM_INFO") // Реклама всем в чат о возможности пробных разов для всех юзеров
}

public rm_limiter_us_info(id)
{
	client_print_color(id, print_team_default, "%l", "RM_LIMITER_US_INFO") // Реклама в чат пользователю, что для больших раз использования нужно купить услугу.
}

public abilitiesOff(id)
{
	if(g_abilities_sp1[id] == true){
		if(g_abilities_sp2[id] == false && g_abilities_sp3[id] == false){
			set_user_maxspeed(id, 250.0);
		}
		client_print_color(id, print_team_default, "%l", "RM_ABILITIES_SPEED1") // Реклама в чат пользователю об окончании действия способности
		g_abilities_sp1[id] = false;
		return PLUGIN_HANDLED;
	}
	else if(g_abilities_sp2[id] == true){
		if(g_abilities_sp1[id] == false && g_abilities_sp3[id] == false){
			set_user_maxspeed(id, 250.0);
		}
		client_print_color(id, print_team_default, "%l", "RM_ABILITIES_SPEED2") // Реклама в чат пользователю об окончании действия способности
		g_abilities_sp2[id] = false;
		return PLUGIN_HANDLED;
	}
	else if(g_abilities_sp3[id] == true){
		if(g_abilities_sp1[id] == false && g_abilities_sp2[id] == false){
			set_user_maxspeed(id, 250.0);
		}
		client_print_color(id, print_team_default, "%l", "RM_ABILITIES_SPEED3") // Реклама в чат пользователю об окончании действия способности
		g_abilities_sp3[id] = false;
		return PLUGIN_HANDLED;
	}
	else if(g_abilities_gr[id] == true){
		set_user_gravity(id, 1.0);
		client_print_color(id, print_team_default, "%l", "RM_ABILITIES_GRAVITY") // Реклама в чат пользователю об окончании действия способности
		g_abilities_gr[id] = false;
		return PLUGIN_HANDLED;
	}
	else if(g_abilities_nc[id] == true){
		set_user_noclip(id, 0);
		client_print_color(id, print_team_default, "%l", "RM_ABILITIES_NOCLIP") // Реклама в чат пользователю об окончании действия способности
		g_abilities_nc[id] = false;
		return PLUGIN_HANDLED;
	}
	else if(g_abilities_hd[id] == true){
		set_entity_visibility(id,1);
		client_print_color(id, print_team_default, "%l", "RM_ABILITIES_HIDE") // Реклама в чат пользователю об окончании действия способности
		g_abilities_hd[id] = false;
		return PLUGIN_HANDLED;
	}
	return PLUGIN_HANDLED;
}

public cmdRealMenu(id, level, cid)
{
	new pRnd = get_pcvar_num(RM_ROUND_COUNT)  // объявим переменную

	if(get_pcvar_num(RM_ROUND) == 1 && g_Round <= pRnd)
	{
		new RndCount = pRnd - g_Round
		client_print_color(id, print_team_default, "%l", "RM_MENU_ROUND", RndCount + 1)
		return PLUGIN_HANDLED;
	}

	if(get_pcvar_num(RM_SOUND_MENU) == 1)
	{
		if(get_pcvar_num(RM_SOUND_MENU_STOP) == 1){
			if(g_sound_menu[id] == false){
				SendAudio(id, RM_SND_HELLO);
			}
			g_sound_menu[id] = true;
			showMenu(id);
			return PLUGIN_HANDLED;
		}
		SendAudio(id, RM_SND_HELLO);
	}

	showMenu(id);
	return PLUGIN_HANDLED;
}

showMenu(id)
{
	new sFlagUsers = get_user_flags(id)

	if(g_NextMenu[id] == 1){
		new rmBody_2[512]
		new len = formatex(rmBody_2, charsmax(rmBody_2), (g_ColorMenu ? "\y%L^n^n" : "%L^n^n"), id, "RM_MENU_NAME")

		if(get_pcvar_num(RM_LIMITER) == 1 && sFlagUsers & GL_FLAG)
		{
			//оптимизируем данные для подстановки (ибо слшиком большой код)
			new pLimit_spw = get_pcvar_num(RM_LIMITER_SPAWN) - g_limit_spw[id]
			new pLimit_hide = get_pcvar_num(RM_LIMITER_HIDE) - g_limit_hide[id]

			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, (g_ColorMenu ? "\r1. \w%L^n" : "1. %L^n"), id, "RM_MENU_ITEM9")
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, (g_ColorMenu ? "\r2. \w%L^n" : "2. %L^n"), id, "RM_MENU_LIMIT7", pLimit_spw)
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, (g_ColorMenu ? "\r3. \w%L^n" : "3. %L^n"), id, "RM_MENU_LIMIT8", pLimit_hide)
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, "^n")
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, "^n")
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, "^n")
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, "^n")
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, "^n^n")
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, (g_ColorMenu ? "\r9. \w%L^n" : "9. %L^n"), id, "RM_MENU_BACK")
		}
		else if(get_pcvar_num(RM_LIMITER_USER) == 1 && sFlagUsers & MULTI_FLAGS)
		{
			//оптимизируем данные для подстановки (ибо слшиком большой код)
			new pLimit_spw_us = get_pcvar_num(RM_LM_SPAWN_USER) - g_lm_spw_user[id]
			new pLimit_hide_us = get_pcvar_num(RM_LM_HIDE_USER) - g_lm_hide_user[id]

			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, (g_ColorMenu ? "\r1. \w%L^n" : "1. %L^n"), id, "RM_MENU_ITEM9")
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, (g_ColorMenu ? "\r2. \w%L^n" : "2. %L^n"), id, "RM_MENU_LIMIT7", pLimit_spw_us)
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, (g_ColorMenu ? "\r3. \w%L^n" : "3. %L^n"), id, "RM_MENU_LIMIT8", pLimit_hide_us)
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, "^n")
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, "^n")
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, "^n")
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, "^n")
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, "^n^n")
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, (g_ColorMenu ? "\r9. \w%L^n" : "9. %L^n"), id, "RM_MENU_BACK")
		}
		else
		{
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, (g_ColorMenu ? "\r1. \w%L^n" : "1. %L^n"), id, "RM_MENU_ITEM9")
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, (g_ColorMenu ? "\r2. \w%L^n" : "2. %L^n"), id, "RM_MENU_ITEM10")
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, (g_ColorMenu ? "\r3. \w%L^n" : "3. %L^n"), id, "RM_MENU_ITEM11")
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, "^n")
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, "^n")
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, "^n")
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, "^n")
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, "^n^n")
			len += formatex(rmBody_2[len], charsmax(rmBody_2) - len, (g_ColorMenu ? "\r9. \w%L^n" : "9. %L^n"), id, "RM_MENU_BACK")
		}

		formatex(rmBody_2[len], charsmax(rmBody_2) - len, (g_ColorMenu ? "\r0. \w%L" : "0. %L"), id, "RM_MENU_EXIT")

		show_menu(id, MENU_KEY_0|MENU_KEY_1|MENU_KEY_2|MENU_KEY_3|MENU_KEY_4|MENU_KEY_5|MENU_KEY_6|MENU_KEY_7|MENU_KEY_8|MENU_KEY_9, rmBody_2, -1, "Next-Menu")
	}
	else
	{
		new rmBody_1[512]
		new len = formatex(rmBody_1, charsmax(rmBody_1), (g_ColorMenu ? "\y%L^n^n" : "%L^n^n"), id, "RM_MENU_NAME")

		if(get_pcvar_num(RM_LIMITER) == 1 && sFlagUsers & GL_FLAG)
		{
			//оптимизируем данные для подстановки (ибо слшиком большой код)
			new pLimit_sp1 = get_pcvar_num(RM_LIMITER_SPEED1) - g_limit_sp1[id]
			new pLimit_sp2 = get_pcvar_num(RM_LIMITER_SPEED2) - g_limit_sp2[id]
			new pLimit_sp3 = get_pcvar_num(RM_LIMITER_SPEED3) - g_limit_sp3[id]
			new pLimit_sh = get_pcvar_num(RM_LIMITER_SHIELD) - g_limit_sh[id]
			new pLimit_gr = get_pcvar_num(RM_LIMITER_GRAVITY) - g_limit_gr[id]
			new pLimit_nc = get_pcvar_num(RM_LIMITER_NOCLIP) - g_limit_nc[id]

			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r1. \w%L^n" : "1. %L^n"), id, "RM_MENU_ITEM1")
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r2. \w%L^n" : "2. %L^n"), id, "RM_MENU_LIMIT1", pLimit_sp1)
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r3. \w%L^n" : "3. %L^n"), id, "RM_MENU_LIMIT2", pLimit_sp2)
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r4. \w%L^n" : "4. %L^n"), id, "RM_MENU_LIMIT3", pLimit_sp3)
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r5. \w%L^n" : "5. %L^n"), id, "RM_MENU_LIMIT4", pLimit_sh)
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r6. \w%L^n" : "6. %L^n"), id, "RM_MENU_LIMIT5", pLimit_gr)
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r7. \w%L^n" : "7. %L^n"), id, "RM_MENU_ITEM7")
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r8. \w%L^n^n" : "8. %L^n^n"), id, "RM_MENU_LIMIT6", pLimit_nc)
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r9. \w%L^n" : "9. %L^n"), id, "RM_MENU_NEXT")
		}
		else if(get_pcvar_num(RM_LIMITER_USER) == 1 && sFlagUsers & MULTI_FLAGS)
		{
			//оптимизируем данные для подстановки (ибо слшиком большой код)
			new pLimit_sp1_us = get_pcvar_num(RM_LM_SPEED1_USER) - g_lm_sp1_user[id]
			new pLimit_sp2_us = get_pcvar_num(RM_LM_SPEED2_USER) - g_lm_sp2_user[id]
			new pLimit_sp3_us = get_pcvar_num(RM_LM_SPEED3_USER) - g_lm_sp3_user[id]
			new pLimit_sh_us = get_pcvar_num(RM_LIMITER_SHIELD) - g_lm_sh_user[id]
			new pLimit_gr_us = get_pcvar_num(RM_LM_SHIELD_USER) - g_lm_gr_user[id]
			new pLimit_nc_us = get_pcvar_num(RM_LM_NOCLIP_USER) - g_lm_nc_user[id]

			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r1. \w%L^n" : "1. %L^n"), id, "RM_MENU_ITEM1")
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r2. \w%L^n" : "2. %L^n"), id, "RM_MENU_LIMIT1", pLimit_sp1_us)
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r3. \w%L^n" : "3. %L^n"), id, "RM_MENU_LIMIT2", pLimit_sp2_us)
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r4. \w%L^n" : "4. %L^n"), id, "RM_MENU_LIMIT3", pLimit_sp3_us)
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r5. \w%L^n" : "5. %L^n"), id, "RM_MENU_LIMIT4", pLimit_sh_us)
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r6. \w%L^n" : "6. %L^n"), id, "RM_MENU_LIMIT5", pLimit_gr_us)
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r7. \w%L^n" : "7. %L^n"), id, "RM_MENU_ITEM7")
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r8. \w%L^n^n" : "8. %L^n^n"), id, "RM_MENU_LIMIT6", pLimit_nc_us)
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r9. \w%L^n" : "9. %L^n"), id, "RM_MENU_NEXT")
		}
		else
		{
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r1. \w%L^n" : "1. %L^n"), id, "RM_MENU_ITEM1")
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r2. \w%L^n" : "2. %L^n"), id, "RM_MENU_ITEM2")
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r3. \w%L^n" : "3. %L^n"), id, "RM_MENU_ITEM3")
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r4. \w%L^n" : "4. %L^n"), id, "RM_MENU_ITEM4")
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r5. \w%L^n" : "5. %L^n"), id, "RM_MENU_ITEM5")
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r6. \w%L^n" : "6. %L^n"), id, "RM_MENU_ITEM6")
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r7. \w%L^n" : "7. %L^n"), id, "RM_MENU_ITEM7")
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r8. \w%L^n^n" : "8. %L^n^n"), id, "RM_MENU_ITEM8")
			len += formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r9. \w%L^n" : "9. %L^n"), id, "RM_MENU_NEXT")
		}

		formatex(rmBody_1[len], charsmax(rmBody_1) - len, (g_ColorMenu ? "\r0. \w%L" : "0. %L"), id, "RM_MENU_EXIT")

		show_menu(id, MENU_KEY_0|MENU_KEY_1|MENU_KEY_2|MENU_KEY_3|MENU_KEY_4|MENU_KEY_5|MENU_KEY_6|MENU_KEY_7|MENU_KEY_8|MENU_KEY_9, rmBody_1, -1, "Real-Menu")
	}
}

public realMenu(id, key)
{
	new sFlagUsers = get_user_flags(id)

	if(key == 8)
	{
		g_NextMenu[id] = 1;
		showMenu(id);
	}

	if(key == 9)
	{
		return PLUGIN_HANDLED;
	}

	if(get_pcvar_num(RM_TIMER_ENABLED) == 1 && g_ReloadTime[id] > time()){
		client_print_color(id, print_team_default, "%l", "RM_TIMER_INFO", g_ReloadTime[id] - time())
		showMenu(id);
		return PLUGIN_HANDLED;
	}

	if(key == 0)
	{
		if(sFlagUsers & GL_FLAG || get_pcvar_num(RM_LIMITER_USER) == 1)
		{
			if(!is_user_alive(id)){
				client_print_color(id, print_team_default, "%l", "RM_DEAD_INFO")
				return PLUGIN_HANDLED;
			}

			set_user_maxspeed(id, 250.0);
			set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.50, 1, 0.2, 0.2, 0.1, 0.6);
			show_dhudmessage(id, "%l", "RM_INFO_SPEED1");

			if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
				SendAudio(id, RM_SND_YES);
			}
		}
		else
		{
			set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.45, 3, 1.0, 3.0, 0.1, 1.5);
			show_dhudmessage(id, "%l", "RM_INFO_OFF");

			if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
				SendAudio(id, RM_SND_NO);
			}
			return PLUGIN_HANDLED;
		}
	}
	else if(key == 1)
	{
		if(sFlagUsers & GL_FLAG)
		{
			if(!is_user_alive(id)){
				client_print_color(id, print_team_default, "%l", "RM_DEAD_INFO")
				return PLUGIN_HANDLED;
			}

			if(get_pcvar_num(RM_LIMITER) == 1 && get_pcvar_num(RM_LIMITER_SPEED1) <= g_limit_sp1[id]){
				client_print_color(id, print_team_default, "%l", "RM_LIMITER_INFO")

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_NO);
				}

				showMenu(id);
				return PLUGIN_HANDLED;
			}

			set_user_maxspeed(id, get_user_maxspeed(id) + get_pcvar_num(RM_SPEED_1));
			set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.50, 1, 0.2, 0.2, 0.1, 0.6);
			show_dhudmessage(id, "%l", "RM_INFO_SPEED2");

			if(get_pcvar_num(RM_ABILITIES_ENABLED) == 1){
				if(is_user_connected(id)){
					client_print_color(id, print_team_default, "%l", "RM_ABILITIES_INFO", get_pcvar_num(RM_ABILITIES_SPEED1))
					g_abilities_sp1[id] = true;
					set_task(get_pcvar_float(RM_ABILITIES_SPEED1), "abilitiesOff", id);
				}
			}

			if(get_pcvar_num(RM_TIMER_ENABLED) == 1){
				g_ReloadTime[id] = time() + get_pcvar_num(RM_TIMER_TIME) //Активируем счетчик времени
			}

			if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
				SendAudio(id, RM_SND_YES);
			}

			if(get_pcvar_num(RM_LIMITER) == 1){
				g_limit_sp1[id]++;
			}
		}
		else
		{
			if(get_pcvar_num(RM_LIMITER_USER) == 1)
			{
				if(!is_user_alive(id)){
					client_print_color(id, print_team_default, "%l", "RM_DEAD_INFO")
					return PLUGIN_HANDLED;
				}

				if(get_pcvar_num(RM_LM_SPEED1_USER) <= g_lm_sp1_user[id]){
					client_print_color(id, print_team_default, "%l", "RM_LIMITER_INFO")

					if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
						SendAudio(id, RM_SND_NO);
					}

					showMenu(id);
					return PLUGIN_HANDLED;
				}

				set_user_maxspeed(id, get_user_maxspeed(id) + get_pcvar_num(RM_SPEED_1));
				set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.50, 1, 0.2, 0.2, 0.1, 0.6);
				show_dhudmessage(id, "%l", "RM_INFO_SPEED2");

				if(get_pcvar_num(RM_ABILITIES_ENABLED) == 1){
					if(is_user_connected(id)){
						client_print_color(id, print_team_default, "%l", "RM_ABILITIES_INFO", get_pcvar_num(RM_ABILITIES_SPEED1))
						g_abilities_sp1[id] = true;
						set_task(get_pcvar_float(RM_ABILITIES_SPEED1), "abilitiesOff", id);
					}
				}

				if(get_pcvar_num(RM_TIMER_ENABLED) == 1){
					g_ReloadTime[id] = time() + get_pcvar_num(RM_TIMER_TIME) //Активируем счетчик времени
				}

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_YES);
				}

				if(get_pcvar_num(RM_LIMITER_USER) == 1){
					g_lm_sp1_user[id]++;
				}

				if(is_user_connected(id)){
					set_task(5.0, "rm_limiter_us_info", id);
				}
			}
			else
			{
				set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.45, 3, 1.0, 3.0, 0.1, 1.5);
				show_dhudmessage(id, "%l", "RM_INFO_OFF");

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_NO);
				}
				return PLUGIN_HANDLED;
			}
		}
	}
	else if(key == 2)
	{
		if(sFlagUsers & GL_FLAG)
		{
			if(!is_user_alive(id)){
				client_print_color(id, print_team_default, "%l", "RM_DEAD_INFO")
				return PLUGIN_HANDLED;
			}

			if(get_pcvar_num(RM_LIMITER) == 1 && get_pcvar_num(RM_LIMITER_SPEED2) <= g_limit_sp2[id]){
				client_print_color(id, print_team_default, "%l", "RM_LIMITER_INFO")

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_NO);
				}

				showMenu(id);
				return PLUGIN_HANDLED;
			}

			set_user_maxspeed(id, get_user_maxspeed(id) + get_pcvar_num(RM_SPEED_2));
			set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.50, 1, 0.2, 0.2, 0.1, 0.6);
			show_dhudmessage(id, "%l", "RM_INFO_SPEED3");

			if(get_pcvar_num(RM_ABILITIES_ENABLED) == 1){
				if(is_user_connected(id)){
					client_print_color(id, print_team_default, "%l", "RM_ABILITIES_INFO", get_pcvar_num(RM_ABILITIES_SPEED2))
					g_abilities_sp2[id] = true;
					set_task(get_pcvar_float(RM_ABILITIES_SPEED2), "abilitiesOff", id);
				}
			}

			if(get_pcvar_num(RM_TIMER_ENABLED) == 1){
				g_ReloadTime[id] = time() + get_pcvar_num(RM_TIMER_TIME) //Активируем счетчик времени
			}

			if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
				SendAudio(id, RM_SND_YES);
			}

			if(get_pcvar_num(RM_LIMITER) == 1){
				g_limit_sp2[id]++;
			}
		}
		else
		{
			if(get_pcvar_num(RM_LIMITER_USER) == 1)
			{
				if(!is_user_alive(id)){
					client_print_color(id, print_team_default, "%l", "RM_DEAD_INFO")
					return PLUGIN_HANDLED;
				}

				if(get_pcvar_num(RM_LM_SPEED2_USER) <= g_lm_sp2_user[id]){
					client_print_color(id, print_team_default, "%l", "RM_LIMITER_INFO")

					if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
						SendAudio(id, RM_SND_NO);
					}

					showMenu(id);
					return PLUGIN_HANDLED;
				}

				set_user_maxspeed(id, get_user_maxspeed(id) + get_pcvar_num(RM_SPEED_2));
				set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.50, 1, 0.2, 0.2, 0.1, 0.6);
				show_dhudmessage(id, "%l", "RM_INFO_SPEED3");

				if(get_pcvar_num(RM_ABILITIES_ENABLED) == 1){
					if(is_user_connected(id)){
						client_print_color(id, print_team_default, "%l", "RM_ABILITIES_INFO", get_pcvar_num(RM_ABILITIES_SPEED2))
						g_abilities_sp2[id] = true;
						set_task(get_pcvar_float(RM_ABILITIES_SPEED2), "abilitiesOff", id);
					}
				}

				if(get_pcvar_num(RM_TIMER_ENABLED) == 1){
					g_ReloadTime[id] = time() + get_pcvar_num(RM_TIMER_TIME) //Активируем счетчик времени
				}

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_YES);
				}

				if(get_pcvar_num(RM_LIMITER_USER) == 1){
					g_lm_sp2_user[id]++;
				}

				if(is_user_connected(id)){
					set_task(5.0, "rm_limiter_us_info", id);
				}
			}
			else
			{
				set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.45, 3, 1.0, 3.0, 0.1, 1.5);
				show_dhudmessage(id, "%l", "RM_INFO_OFF");

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_NO);
				}
				return PLUGIN_HANDLED;
			}
		}
	}
	else if(key == 3)
	{
		if(sFlagUsers & GL_FLAG)
		{
			if(!is_user_alive(id)){
				client_print_color(id, print_team_default, "%l", "RM_DEAD_INFO")
				return PLUGIN_HANDLED;
			}

			if(get_pcvar_num(RM_LIMITER) == 1 && get_pcvar_num(RM_LIMITER_SPEED3) <= g_limit_sp3[id]){
				client_print_color(id, print_team_default, "%l", "RM_LIMITER_INFO")

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_NO);
				}

				showMenu(id);
				return PLUGIN_HANDLED;
			}

			set_user_maxspeed(id, get_user_maxspeed(id) + get_pcvar_num(RM_SPEED_3));
			set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.50, 1, 0.2, 0.2, 0.1, 0.6);
			show_dhudmessage(id, "%l", "RM_INFO_SPEED4");

			if(get_pcvar_num(RM_ABILITIES_ENABLED) == 1){
				if(is_user_connected(id)){
					client_print_color(id, print_team_default, "%l", "RM_ABILITIES_INFO", get_pcvar_num(RM_ABILITIES_SPEED3))
					g_abilities_sp3[id] = true;
					set_task(get_pcvar_float(RM_ABILITIES_SPEED3), "abilitiesOff", id);
				}
			}

			if(get_pcvar_num(RM_TIMER_ENABLED) == 1){
				g_ReloadTime[id] = time() + get_pcvar_num(RM_TIMER_TIME) //Активируем счетчик времени
			}

			if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
				SendAudio(id, RM_SND_YES);
			}

			if(get_pcvar_num(RM_LIMITER) == 1){
				g_limit_sp3[id]++;
			}
		}
		else
		{
			if(get_pcvar_num(RM_LIMITER_USER) == 1)
			{
				if(!is_user_alive(id)){
					client_print_color(id, print_team_default, "%l", "RM_DEAD_INFO")
					return PLUGIN_HANDLED;
				}

				if(get_pcvar_num(RM_LM_SPEED3_USER) <= g_lm_sp3_user[id]){
					client_print_color(id, print_team_default, "%l", "RM_LIMITER_INFO")

					if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
						SendAudio(id, RM_SND_NO);
					}

					showMenu(id);
					return PLUGIN_HANDLED;
				}

				set_user_maxspeed(id, get_user_maxspeed(id) + get_pcvar_num(RM_SPEED_3));
				set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.50, 1, 0.2, 0.2, 0.1, 0.6);
				show_dhudmessage(id, "%l", "RM_INFO_SPEED4");

				if(get_pcvar_num(RM_ABILITIES_ENABLED) == 1){
					if(is_user_connected(id)){
						client_print_color(id, print_team_default, "%l", "RM_ABILITIES_INFO", get_pcvar_num(RM_ABILITIES_SPEED3))
						g_abilities_sp3[id] = true;
						set_task(get_pcvar_float(RM_ABILITIES_SPEED3), "abilitiesOff", id);
					}
				}

				if(get_pcvar_num(RM_TIMER_ENABLED) == 1){
					g_ReloadTime[id] = time() + get_pcvar_num(RM_TIMER_TIME) //Активируем счетчик времени
				}

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_YES);
				}

				if(get_pcvar_num(RM_LIMITER_USER) == 1){
					g_lm_sp3_user[id]++;
				}

				if(is_user_connected(id)){
					set_task(5.0, "rm_limiter_us_info", id);
				}
			}
			else
			{
				set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.45, 3, 1.0, 3.0, 0.1, 1.5);
				show_dhudmessage(id, "%l", "RM_INFO_OFF");

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_NO);
				}
				return PLUGIN_HANDLED;
			}
		}
	}
	else if(key == 4)
	{
		if(sFlagUsers & GL_FLAG)
		{
			if(!is_user_alive(id)){
				client_print_color(id, print_team_default, "%l", "RM_DEAD_INFO")
				return PLUGIN_HANDLED;
			}

			if(get_pcvar_num(RM_LIMITER) == 1 && get_pcvar_num(RM_LIMITER_SHIELD) <= g_limit_sh[id]){
				client_print_color(id, print_team_default, "%l", "RM_LIMITER_INFO")

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_NO);
				}

				showMenu(id);
				return PLUGIN_HANDLED;
			}

			give_item(id, "weapon_shield")
			set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.50, 1, 0.2, 0.2, 0.1, 0.6);
			show_dhudmessage(id, "%l", "RM_INFO_SHIELD");

			if(get_pcvar_num(RM_TIMER_ENABLED) == 1){
				g_ReloadTime[id] = time() + get_pcvar_num(RM_TIMER_TIME) //Активируем счетчик времени
			}

			if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
				SendAudio(id, RM_SND_YES);
			}

			if(get_pcvar_num(RM_LIMITER) == 1){
				g_limit_sh[id]++;
			}
		}
		else
		{
			if(get_pcvar_num(RM_LIMITER_USER) == 1)
			{
				if(!is_user_alive(id)){
					client_print_color(id, print_team_default, "%l", "RM_DEAD_INFO")
					return PLUGIN_HANDLED;
				}

				if(get_pcvar_num(RM_LM_SHIELD_USER) <= g_lm_sh_user[id]){
					client_print_color(id, print_team_default, "%l", "RM_LIMITER_INFO")

					if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
						SendAudio(id, RM_SND_NO);
					}

					showMenu(id);
					return PLUGIN_HANDLED;
				}

				give_item(id, "weapon_shield")
				set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.50, 1, 0.2, 0.2, 0.1, 0.6);
				show_dhudmessage(id, "%l", "RM_INFO_SHIELD");

				if(get_pcvar_num(RM_TIMER_ENABLED) == 1){
					g_ReloadTime[id] = time() + get_pcvar_num(RM_TIMER_TIME) //Активируем счетчик времени
				}

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_YES);
				}

				if(get_pcvar_num(RM_LIMITER_USER) == 1){
					g_lm_sh_user[id]++;
				}

				if(is_user_connected(id)){
					set_task(5.0, "rm_limiter_us_info", id);
				}
			}
			else
			{
				set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.45, 3, 1.0, 3.0, 0.1, 1.5);
				show_dhudmessage(id, "%l", "RM_INFO_OFF");

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_NO);
				}
				return PLUGIN_HANDLED;
			}
		}
	}
	else if(key == 5)
	{
		if(sFlagUsers & GL_FLAG)
		{
			if(!is_user_alive(id)){
				client_print_color(id, print_team_default, "%l", "RM_DEAD_INFO")
				return PLUGIN_HANDLED;
			}

			if(get_pcvar_num(RM_LIMITER) == 1 && get_pcvar_num(RM_LIMITER_GRAVITY) <= g_limit_gr[id]){
				client_print_color(id, print_team_default, "%l", "RM_LIMITER_INFO")

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_NO);
				}

				showMenu(id);
				return PLUGIN_HANDLED;
			}

			set_user_gravity(id, get_pcvar_float(RM_GRAVITY));
			set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.50, 1, 0.2, 0.2, 0.1, 0.6);
			show_dhudmessage(id, "%l", "RM_INFO_GRAVITY_ON");

			if(get_pcvar_num(RM_ABILITIES_ENABLED) == 1){
				if(is_user_connected(id)){
					client_print_color(id, print_team_default, "%l", "RM_ABILITIES_INFO", get_pcvar_num(RM_ABILITIES_GRAVITY))
					g_abilities_gr[id] = true;
					set_task(get_pcvar_float(RM_ABILITIES_GRAVITY), "abilitiesOff", id);
				}
			}

			if(get_pcvar_num(RM_TIMER_ENABLED) == 1){
				g_ReloadTime[id] = time() + get_pcvar_num(RM_TIMER_TIME) //Активируем счетчик времени
			}

			if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
				SendAudio(id, RM_SND_YES);
			}

			if(get_pcvar_num(RM_LIMITER) == 1){
				g_limit_gr[id]++;
			}
		}
		else
		{
			if(get_pcvar_num(RM_LIMITER_USER) == 1)
			{
				if(!is_user_alive(id)){
					client_print_color(id, print_team_default, "%l", "RM_DEAD_INFO")
					return PLUGIN_HANDLED;
				}

				if(get_pcvar_num(RM_LM_GRAVITY_USER) <= g_lm_gr_user[id]){
					client_print_color(id, print_team_default, "%l", "RM_LIMITER_INFO")

					if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
						SendAudio(id, RM_SND_NO);
					}

					showMenu(id);
					return PLUGIN_HANDLED;
				}

				set_user_gravity(id, get_pcvar_float(RM_GRAVITY));
				set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.50, 1, 0.2, 0.2, 0.1, 0.6);
				show_dhudmessage(id, "%l", "RM_INFO_GRAVITY_ON");

				if(get_pcvar_num(RM_ABILITIES_ENABLED) == 1){
					if(is_user_connected(id)){
						client_print_color(id, print_team_default, "%l", "RM_ABILITIES_INFO", get_pcvar_num(RM_ABILITIES_GRAVITY))
						g_abilities_gr[id] = true;
						set_task(get_pcvar_float(RM_ABILITIES_GRAVITY), "abilitiesOff", id);
					}
				}

				if(get_pcvar_num(RM_TIMER_ENABLED) == 1){
					g_ReloadTime[id] = time() + get_pcvar_num(RM_TIMER_TIME) //Активируем счетчик времени
				}

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_YES);
				}

				if(get_pcvar_num(RM_LIMITER_USER) == 1){
					g_lm_gr_user[id]++;
				}

				if(is_user_connected(id)){
					set_task(5.0, "rm_limiter_us_info", id);
				}
			}
			else
			{
				set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.45, 3, 1.0, 3.0, 0.1, 1.5);
				show_dhudmessage(id, "%l", "RM_INFO_OFF");

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_NO);
				}
				return PLUGIN_HANDLED;
			}
		}
	}
	else if(key == 6)
	{
		if(sFlagUsers & GL_FLAG || get_pcvar_num(RM_LIMITER_USER) == 1)
		{
			if(!is_user_alive(id)){
				client_print_color(id, print_team_default, "%l", "RM_DEAD_INFO")
				return PLUGIN_HANDLED;
			}

			set_user_gravity(id, 1.0);
			set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.50, 1, 0.2, 0.2, 0.1, 0.6);
			show_dhudmessage(id, "%l", "RM_INFO_GRAVITY_OFF");

			if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
				SendAudio(id, RM_SND_YES);
			}
		}
		else
		{
			set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.45, 3, 1.0, 3.0, 0.1, 1.5);
			show_dhudmessage(id, "%l", "RM_INFO_OFF");

			if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
				SendAudio(id, RM_SND_NO);
			}
			return PLUGIN_HANDLED;
		}
	}
	else if(key == 7)
	{
		if(sFlagUsers & GL_FLAG)
		{
			if(!is_user_alive(id)){
				client_print_color(id, print_team_default, "%l", "RM_DEAD_INFO")
				return PLUGIN_HANDLED;
			}

			if(get_pcvar_num(RM_LIMITER) == 1 && get_pcvar_num(RM_LIMITER_NOCLIP) <= g_limit_nc[id]){
				client_print_color(id, print_team_default, "%l", "RM_LIMITER_INFO")

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_NO);
				}

				showMenu(id);
				return PLUGIN_HANDLED;
			}

			set_user_noclip(id, 1);
			set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.50, 1, 0.2, 0.2, 0.1, 0.6);
			show_dhudmessage(id, "%l", "RM_INFO_NOCLIP_ON");

			if(get_pcvar_num(RM_ABILITIES_ENABLED) == 1){
				if(is_user_connected(id)){
					client_print_color(id, print_team_default, "%l", "RM_ABILITIES_INFO", get_pcvar_num(RM_ABILITIES_NOCLIP))
					g_abilities_nc[id] = true;
					set_task(get_pcvar_float(RM_ABILITIES_NOCLIP), "abilitiesOff", id);
				}
			}

			if(get_pcvar_num(RM_TIMER_ENABLED) == 1){
				g_ReloadTime[id] = time() + get_pcvar_num(RM_TIMER_TIME) //Активируем счетчик времени
			}

			if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
				SendAudio(id, RM_SND_YES);
			}

			if(get_pcvar_num(RM_LIMITER) == 1){
				g_limit_nc[id]++;
			}
		}
		else
		{
			if(get_pcvar_num(RM_LIMITER_USER) == 1)
			{
				if(!is_user_alive(id)){
					client_print_color(id, print_team_default, "%l", "RM_DEAD_INFO")
					return PLUGIN_HANDLED;
				}

				if(get_pcvar_num(RM_LM_NOCLIP_USER) <= g_lm_nc_user[id]){
					client_print_color(id, print_team_default, "%l", "RM_LIMITER_INFO")

					if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
						SendAudio(id, RM_SND_NO);
					}

					showMenu(id);
					return PLUGIN_HANDLED;
				}

				set_user_noclip(id, 1);
				set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.50, 1, 0.2, 0.2, 0.1, 0.6);
				show_dhudmessage(id, "%l", "RM_INFO_NOCLIP_ON");

				if(get_pcvar_num(RM_ABILITIES_ENABLED) == 1){
					if(is_user_connected(id)){
						client_print_color(id, print_team_default, "%l", "RM_ABILITIES_INFO", get_pcvar_num(RM_ABILITIES_NOCLIP))
						g_abilities_nc[id] = true;
						set_task(get_pcvar_float(RM_ABILITIES_NOCLIP), "abilitiesOff", id);
					}
				}

				if(get_pcvar_num(RM_TIMER_ENABLED) == 1){
					g_ReloadTime[id] = time() + get_pcvar_num(RM_TIMER_TIME) //Активируем счетчик времени
				}

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_YES);
				}

				if(get_pcvar_num(RM_LIMITER_USER) == 1){
					g_lm_nc_user[id]++;
				}

				if(is_user_connected(id)){
					set_task(5.0, "rm_limiter_us_info", id);
				}
			}
			else
			{
				set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.45, 3, 1.0, 3.0, 0.1, 1.5);
				show_dhudmessage(id, "%l", "RM_INFO_OFF");

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_NO);
				}
				return PLUGIN_HANDLED;
			}
		}
	}
	return PLUGIN_HANDLED;
}

public nextMenu(id, key)
{
	new sFlagUsers = get_user_flags(id)

	if(key == 8)
	{
		g_NextMenu[id] = 0;
		showMenu(id);
	}

	if(key == 9)
	{
		g_NextMenu[id] = 0;
		return PLUGIN_HANDLED;
	}

	if(get_pcvar_num(RM_TIMER_ENABLED) == 1 && g_ReloadTime[id] > time()){
		client_print_color(id, print_team_default, "%l", "RM_TIMER_INFO", g_ReloadTime[id] - time())
		showMenu(id);
		return PLUGIN_HANDLED;
	}

	if(key == 0)
	{
		if(sFlagUsers & GL_FLAG || get_pcvar_num(RM_LIMITER_USER) == 1)
		{
			if(!is_user_alive(id)){
				client_print_color(id, print_team_default, "%l", "RM_DEAD_INFO")
				return PLUGIN_HANDLED;
			}

			set_user_noclip(id, 0);
			set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.50, 1, 0.2, 0.2, 0.1, 0.6);
			show_dhudmessage(id, "%l", "RM_INFO_NOCLIP_OFF");

			if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
				SendAudio(id, RM_SND_YES);
			}

			g_NextMenu[id] = 0;
		}
		else
		{
			set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.45, 3, 1.0, 3.0, 0.1, 1.5);
			show_dhudmessage(id, "%l", "RM_INFO_OFF");

			if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
				SendAudio(id, RM_SND_NO);
			}

			g_NextMenu[id] = 0;
			return PLUGIN_HANDLED;
		}
	}
	else if(key == 1)
	{
		if(sFlagUsers & GL_FLAG)
		{
			if(!is_user_alive(id)){
				client_print_color(id, print_team_default, "%l", "RM_DEAD_INFO")
				return PLUGIN_HANDLED;
			}

			if(get_pcvar_num(RM_LIMITER) == 1 && get_pcvar_num(RM_LIMITER_SPAWN) <= g_limit_spw[id]){
				client_print_color(id, print_team_default, "%l", "RM_LIMITER_INFO")

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_NO);
				}

				showMenu(id);
				return PLUGIN_HANDLED;
			}

			spawn(id);
			set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.50, 1, 0.2, 0.2, 0.1, 0.6);
			show_dhudmessage(id, "%l", "RM_INFO_SPAWN");
			g_NextMenu[id] = 0;

			if(get_pcvar_num(RM_TIMER_ENABLED) == 1){
				g_ReloadTime[id] = time() + get_pcvar_num(RM_TIMER_TIME) //Активируем счетчик времени
			}

			if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
				SendAudio(id, RM_SND_YES);
			}

			if(get_pcvar_num(RM_LIMITER) == 1){
				g_limit_spw[id]++;
			}
		}
		else
		{
			if(get_pcvar_num(RM_LIMITER_USER) == 1)
			{
				if(!is_user_alive(id)){
					client_print_color(id, print_team_default, "%l", "RM_DEAD_INFO")
					return PLUGIN_HANDLED;
				}

				if(get_pcvar_num(RM_LM_SPAWN_USER) <= g_lm_spw_user[id]){
					client_print_color(id, print_team_default, "%l", "RM_LIMITER_INFO")

					if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
						SendAudio(id, RM_SND_NO);
					}

					showMenu(id);
					return PLUGIN_HANDLED;
				}

				spawn(id);
				set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.50, 1, 0.2, 0.2, 0.1, 0.6);
				show_dhudmessage(id, "%l", "RM_INFO_SPAWN");
				g_NextMenu[id] = 0;

				if(get_pcvar_num(RM_TIMER_ENABLED) == 1){
					g_ReloadTime[id] = time() + get_pcvar_num(RM_TIMER_TIME) //Активируем счетчик времени
				}

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_YES);
				}

				if(get_pcvar_num(RM_LIMITER_USER) == 1){
					g_lm_spw_user[id]++;
				}

				if(is_user_connected(id)){
					set_task(5.0, "rm_limiter_us_info", id);
				}
			}
			else
			{
				set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.45, 3, 1.0, 3.0, 0.1, 1.5);
				show_dhudmessage(id, "%l", "RM_INFO_OFF");

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_NO);
				}
				return PLUGIN_HANDLED;
			}
		}
	}
	else if(key == 2) 
	{
		if(sFlagUsers & GL_FLAG)
		{
			if(!is_user_alive(id)){
				client_print_color(id, print_team_default, "%l", "RM_DEAD_INFO")
				return PLUGIN_HANDLED;
			}

			if(get_pcvar_num(RM_LIMITER) == 1 && get_pcvar_num(RM_LIMITER_HIDE) <= g_limit_hide[id]){
				client_print_color(id, print_team_default, "%l", "RM_LIMITER_INFO")

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_NO);
				}

				showMenu(id);
				return PLUGIN_HANDLED;
			}

			set_entity_visibility(id,0);
			set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.50, 1, 0.2, 0.2, 0.1, 0.6);
			show_dhudmessage(id, "%l", "RM_INFO_HIDE");
			g_NextMenu[id] = 0;

			if(get_pcvar_num(RM_ABILITIES_ENABLED) == 1){
				if(is_user_connected(id)){
					client_print_color(id, print_team_default, "%l", "RM_ABILITIES_INFO", get_pcvar_num(RM_ABILITIES_HIDE))
					g_abilities_hd[id] = true;
					set_task(get_pcvar_float(RM_ABILITIES_HIDE), "abilitiesOff", id);
				}
			}

			if(get_pcvar_num(RM_TIMER_ENABLED) == 1){
				g_ReloadTime[id] = time() + get_pcvar_num(RM_TIMER_TIME) //Активируем счетчик времени
			}

			if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
				SendAudio(id, RM_SND_YES);
			}

			if(get_pcvar_num(RM_LIMITER) == 1){
				g_limit_hide[id]++;
			}
		}
		else
		{
			if(get_pcvar_num(RM_LIMITER_USER) == 1)
			{
				if(!is_user_alive(id)){
					client_print_color(id, print_team_default, "%l", "RM_DEAD_INFO")
					return PLUGIN_HANDLED;
				}

				if(get_pcvar_num(RM_LM_HIDE_USER) <= g_lm_hide_user[id]){
					client_print_color(id, print_team_default, "%l", "RM_LIMITER_INFO")

					if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
						SendAudio(id, RM_SND_NO);
					}

					showMenu(id);
					return PLUGIN_HANDLED;
				}

				set_entity_visibility(id,0);
				set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.50, 1, 0.2, 0.2, 0.1, 0.6);
				show_dhudmessage(id, "%l", "RM_INFO_HIDE");
				g_NextMenu[id] = 0;

				if(get_pcvar_num(RM_ABILITIES_ENABLED) == 1){
					if(is_user_connected(id)){
						client_print_color(id, print_team_default, "%l", "RM_ABILITIES_INFO", get_pcvar_num(RM_ABILITIES_HIDE))
						g_abilities_hd[id] = true;
						set_task(get_pcvar_float(RM_ABILITIES_HIDE), "abilitiesOff", id);
					}
				}

				if(get_pcvar_num(RM_TIMER_ENABLED) == 1){
					g_ReloadTime[id] = time() + get_pcvar_num(RM_TIMER_TIME) //Активируем счетчик времени
				}

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_YES);
				}

				if(get_pcvar_num(RM_LIMITER_USER) == 1){
					g_lm_hide_user[id]++;
				}

				if(is_user_connected(id)){
					set_task(5.0, "rm_limiter_us_info", id);
				}
			}
			else
			{
				set_dhudmessage(random_num(10,255), random_num(10,255), random_num(10,255), -1.0, -0.45, 3, 1.0, 3.0, 0.1, 1.5);
				show_dhudmessage(id, "%l", "RM_INFO_OFF");

				if(get_pcvar_num(RM_SOUND_GLOBAL) == 1){
					SendAudio(id, RM_SND_NO);
				}
				return PLUGIN_HANDLED;
			}
		}
	}
	else if(key == 3 || key == 4 || key == 5 || key == 6 || key == 7)
	{
		showMenu(id);
	}
	return PLUGIN_HANDLED;
}

stock SendAudio(id, const audio[], pitch = 100){
	static iMsgSendAudio;

	if(!iMsgSendAudio){
		iMsgSendAudio = get_user_msgid("SendAudio");
	}

	message_begin(id ? MSG_ONE_UNRELIABLE : MSG_BROADCAST, iMsgSendAudio, .player = id);
	write_byte(id);
	write_string(audio);
	write_short(pitch);
	message_end();
}

stock rm_get_configsdir(name[], len) //проверка на директории
{
	new s_Dir[64];
	get_localinfo("amxx_configsdir", s_Dir, 63)

	return formatex(name, len, "%s/%s", s_Dir, RM_DIR)
}